Attribute VB_Name = "smtpin"
Option Explicit

Private Type rcptaddr
  address As String
  addrtype As String
  name As String
  domain As String
End Type

Const VERSION = "3.0"
Global GConnid As Integer
Dim sRemoteIP As String
Dim sRemoteHost As String
Dim sRcpt() As rcptaddr


Dim iRcptCnt As Integer
Dim sinbuffer As String
Dim imsgFh As String
Dim sMsgID As String
Dim bMailFrom As Boolean
Dim sMailFrom As String
Dim bRecMsg As Boolean
Dim Timeout As Integer
Dim bactive As Boolean




Sub InitInboundConnection(ByVal Connid As Integer)
  imsgFh = 0
  Timeout = -1 ' off!
  bMailFrom = False
  iRcptCnt = 0
  
  sRemoteHost = Form1.tcpd.GetRemoteAddr(Connid)
  bRecMsg = False
  bactive = True
  Form1.List2.AddItem "Receiving Connection from:" & sRemoteHost, 0
  If Not (sRemoteHost = 1694542016) Then
    smtpsend "500 SMTP Not working" & vbCrLf, Connid
    Form1.tcpd.Close (Connid)
    Exit Sub
  End If
  sinbuffer = ""
  smtpsend "220 SMTP Server Version " & VERSION & " Simple Mail Transfer Ready." & vbCrLf, Connid

End Sub

Sub InboundRemoteCmd(indata As String, ByVal Connid As Integer)
  Dim data As String
  Dim sReturnCmd As String, iStopFlag As Integer
  Dim sTempBuffer As String
  data = indata
  
  ' if we are receiving the message data
 If bRecMsg Then
'   SMTPtalk.OUR_DOMAIN "C: " & Left(data, Len(data) - 2)
    If Not Trim(data) = "." Then
      Print #imsgFh, data
      Exit Sub
    Else
    Print #imsgFh, "."
    'find out if we have received teh end of message flag.
     'we have the eof.!
      bRecMsg = False
      Print #imsgFh, ""
      Close #imsgFh
      If Processmail() Then
        smtpsend "250 Message ID: " & sMsgID & ". Mail Being Delivered" & vbCrLf, Connid
        'add to a list of message counted!!???^
      Else
        smtpsend "554 Processing Error - Cannot deliver Mail." & vbCrLf, Connid
      End If
      Kill sMsgID
      bMailFrom = False
      iRcptCnt = 0
      imsgFh = 0
      sMsgID = ""
    End If
  Else
    ' we arnt receiving the message data so process the command
    Form1.List2.AddItem "C:" & data, 0
  '  data = Left(data, Len(data) - 2)
    Select Case UCase(Left(data, 4))
      Case "HELO"
        cmd_HELO Trim(Mid(data, 5)), Connid
      
      Case "MAIL"
        cmd_MAIL Trim(Mid(data, 5)), Connid
      
      Case "RCPT"
        cmd_RCPT Trim(Mid(data, 5)), Connid
      
      Case "VRFY"
        cmd_VRFY Trim(Mid(data, 5)), Connid
    
      Case "DATA"
        If bMailFrom Then
          If iRcptCnt > 0 Then
            Print #imsgFh, "DATA"
            Print #imsgFh, "Received: From " & sRemoteHost
            bRecMsg = True
            'was 354???
            smtpsend "354 Start mail input; end with <CRLF>.<CRLF>" & vbCrLf, Connid
          Else
            ' we dont have any receipeints, send the error message
            smtpsend "503 No reciepients specified" & vbCrLf, Connid
          End If
        Else
          smtpsend "503 No mail from specified" & vbCrLf, Connid
        End If
        
      Case "NOOP"
        smtpsend "250 OK" & vbCrLf, Connid
        
        
      Case "RSET"
        cmd_RSET Connid
      
      Case "HELP"
        cmd_HELP Trim(Mid(data, 5)), Connid
      
      Case "QUIT"
        smtpsend "221 " & Trim(CCmail_to_smtp.inetDOMAIN) & "says goodbye to " & sRemoteHost & " [" & sRemoteIP & "] at " & Format(Now, "ddd dd mmm yyy hh:mm:dd") & vbCrLf, Connid
        SMTPCloseConnection Connid
        Exit Sub
        
      Case Else
        smtpsend "500 Syntax Error, Command not known.", Connid
    End Select
  End If
End Sub

Sub smtpsend(outdata As String, ByVal Connid As Integer)
  Form1.List2.AddItem "S:" & outdata, 0
  Form1.tcpd.Send Connid, outdata, Len(outdata)
End Sub

Sub SMTPCloseConnection(ByVal Connid As Integer)
  If imsgFh > 0 Then
    Close #imsgFh
    If Not Dir(sMsgID) = "" Then
      Kill sMsgID
    End If
  End If
  Form1.tcpd.Close Connid
  Form1.List2.AddItem "Closed the connection", 0
End Sub

Sub cmd_HELO(data As String, ByVal Connid As Integer)
  sRemoteHost = data
  smtpsend "250 " & CCmail_to_smtp.inetDOMAIN & vbCrLf, Connid
End Sub

Sub cmd_HELP(data As String, ByVal Connid As Integer)
  If data = "" Then
    smtpsend "211-supported commands are HELO, MAIL, RCPT, VRFY, HELP, NOOP, RSET, QUIT" & vbCrLf, Connid
    smtpsend "211 to get help on a specified command use HELP" & vbCrLf, Connid
  Else
    Select Case UCase(data)
      Case "HELO"
        smtpsend "214-Usage: HELO domain" & vbCrLf, Connid
        smtpsend "214 Example: HELO domain" & vbCrLf, Connid
      
      Case "HELP"
        smtpsend "214-Usage: HELP or HELP" & vbCrLf, Connid
        smtpsend "214 Example: HELP HELP" & vbCrLf, Connid
      
      Case "MAIL"
        smtpsend "214-Usage: MAIL FROM:" & vbCrLf, Connid
        smtpsend "214 Example: MAIL FROM:" & vbCrLf, Connid
        
      Case "NOOP"
        smtpsend "214-Usage: NOOP" & vbCrLf, Connid
     
      Case "QUIT"
        smtpsend "214-Usage: QUIT" & vbCrLf, Connid
 
      Case "RCPT"
        smtpsend "214-Usage: RCPT TO:" & vbCrLf, Connid
        smtpsend "214 Example: RCPT TO:" & vbCrLf, Connid
      
      Case "RSET"
        smtpsend "214-Usage: RSET" & vbCrLf, Connid
 
 
      Case "VRFY"
        smtpsend "214-Usage: VRFY user" & vbCrLf, Connid
        smtpsend "214 Example: VRFY smith" & vbCrLf, Connid

      Case Else
        smtpsend "501 Syntax Error" & vbCrLf, Connid
  
    End Select
  End If
End Sub

Sub cmd_MAIL(indata As String, ByVal Connid As Integer)
  Dim data As String
  Dim tempusername  As String
  data = indata
  
  If sRemoteHost = "" Then
    smtpsend "503 No HELO command specified - you are out of sequence" & vbCrLf, Connid
    Exit Sub
  End If
  If UCase(Left(data, 5)) = "FROM:" Then
    data = Trim(Mid(data, 6))
    If InStr(data, "<") > 0 Then
      data = Trim(Mid(data, InStr(data, "<") + 1))
      If InStr(data, ">") > 0 Then
        data = Trim(Left(data, InStr(data, ">") - 1))
        sMailFrom = data
        ' code to reverse address for UUCP
        If Not (Trim(data) = "") Then
          tempusername = Left(sMailFrom, InStr(sMailFrom, "@") - 1)
          If InStr(tempusername, "!") > 0 Then
            sMailFrom = Mid(tempusername, InStr(tempusername, "!") + 1) & "@" & Left(tempusername, InStr(tempusername, "!") - 1)
          End If
        Else
          sMailFrom = ""
        End If
        bMailFrom = True
        sMsgID = CCmail_to_smtp.CCMAILWORKINGFOLDER & "smtpin.txt"
        If Not Dir(sMsgID) = "" Then
          Kill sMsgID
        End If
        imsgFh = FreeFile
        
        Open sMsgID For Output Lock Read Write As #imsgFh
        Print #imsgFh, "HELO " & sRemoteHost
        Print #imsgFh, "MAIL FROM:<" & sMailFrom & ">"
        smtpsend "250 OK" & vbCrLf, Connid
        Exit Sub
      End If
    End If
  End If
  smtpsend "501 Syntax Error", Connid
End Sub

Sub cmd_RCPT(indata As String, ByVal Connid As Integer)
  Dim data As String
  Dim leftstring As String
  data = indata
  If Not bMailFrom Then
    smtpsend "503 No mail from sender specified" & vbCrLf, Connid
    Exit Sub
  End If
  If Not UCase(Left(data, 3)) = "TO:" Then
    smtpsend "503 Syntax error" & vbCrLf, Connid
    Exit Sub
  End If
  data = Trim(Mid(data, 4))
  If Left(data, 1) = "<" And Right(data, 1) = ">" Then
    data = Trim(Mid(data, 2, (Len(data) - 2)))
    If Not data = "" Then
      ' quick user OK check!
      ' format left of @ is xxx.xxxx.ccmail
      If InStr(LCase(data), ".ccmail@") < 1 Then
        smtpsend "550 User not know at this address" & vbCrLf, Connid
        Exit Sub
      End If
      leftstring = Left(LCase(data), InStr(LCase(data), ".ccmail@") - 1)
      If InStr(leftstring, ".") < 1 Then
        smtpsend "550 ccmail gateway needs user.postoffice.ccmail" & vbCrLf, Connid
        Exit Sub
      End If
    
      iRcptCnt = iRcptCnt + 1
      ReDim Preserve sRcpt(iRcptCnt)
      sRcpt(iRcptCnt).address = data
      Print #imsgFh, "RCPT TO:<" & data & ">"
      smtpsend "250 receipient OK" & vbCrLf, Connid
      Exit Sub
    End If
  End If
  smtpsend "552 error processing receipient at this time" & vbCrLf, Connid
End Sub

Sub cmd_RSET(ByVal Connid As Integer)
  If imsgFh > 0 Then
    Close #imsgFh
    Kill sMsgID
  End If
  imsgFh = 0
  bMailFrom = False
  iRcptCnt = 0
  sMsgID = ""
  smtpsend "250 OK" & vbCrLf, Connid

End Sub

Sub cmd_VRFY(address As String, ByVal Connid As Integer)
  smtpsend "503 Not yet buddy" & vbCrLf, Connid

End Sub




Function Processmail()
' go through recepients.
' rules :=


  'Messagetypes CCMAIL
  
  
  Dim i As Integer, j As Integer
  Dim ccmailcheck As String
  Dim internetexist   As Boolean
  Dim localexist   As Boolean
  Dim ccmailexist   As Boolean
  Dim faxexist   As Boolean
  Dim errorexist As Boolean

  
   internetexist = False
  localexist = False
  ccmailexist = False
  faxexist = False
  errorexist = False
  
  
  
  
  For i = 1 To iRcptCnt
    ' is it local mail
     sRcpt(i).addrtype = "CCMAIL"
    
    
    sRcpt(i).domain = inetDOMAIN
    sRcpt(i).name = Trim(Left(sRcpt(i).address, InStr(sRcpt(i).address, "@") - 1))
  Next
    
    sendtoccmail
   Processmail = True ' may change this later
End Function


Sub sendtoccmail()
 Dim importfilename As String
' need to create a file with all the address present for delivery, like internet one
  Dim iFH As Integer, astring As String, i As Integer
  Dim newfilename As String
  iFH = FreeFile
  newfilename = CCmail_to_smtp.CCMAILWORKINGFOLDER & "smtp2cc.txt"
  Open newfilename For Output Lock Read Write As #iFH
  imsgFh = FreeFile
  Open sMsgID For Input As #imsgFh
  Do While Not EOF(imsgFh)
    Line Input #imsgFh, astring
    If UCase(astring) = "DATA" Then
      Exit Do
    End If
  Loop
  Print #iFH, "MAIL FROM: <" & sMailFrom & ">"
  For i = 1 To UBound(sRcpt)
      If sRcpt(i).addrtype = "CCMAIL" Then
       Print #iFH, "RCPT TO: <" & sRcpt(i).name & "@" & sRcpt(i).domain & ">"
     End If
  Next
  Print #iFH, "DATA"
      

  Do While Not EOF(imsgFh)
      Line Input #imsgFh, astring
      Print #iFH, astring
  Loop
  Close #imsgFh
  Close #iFH
  imsgFh = -1
  parse_smtp "smtp2cc.txt"
 importfilename = Create_ccimport_file()
       If Not ccimport_file(importfilename) Then
        FileCopy CCMAILWORKINGFOLDER & "smtp2cc.txt", CCMAILEXPORTFOLDER & "probs\" & "smtp2cc.txt"
     End If
    If Not Dir(importfilename) = "" Then
        Kill importfilename
      End If
      If Not (Dir(CCmail_to_smtp.CCMAILWORKINGFOLDER & "smtp2cc.txt") = "") Then
        Kill CCmail_to_smtp.CCMAILWORKINGFOLDER & "smtp2cc.txt"
      End If
End Sub



